
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java访问数据库的速度瓶颈问题的分析及解决 / iVAN</title>

    <meta name="description" content="Java访问数据库的速度瓶颈问题的分析及解决 访问|解决|数据|数据库|速度|问题 内容: 速度瓶颈问题的提出 JDBC访问数据库的机制 不同模式的JDBC接口的选择 Java程序中SQL语句格式的优化 软件模型中对数据库访问的设计模式的优化 将深入研究的问题 参考资料 关于作者 FoolsGarden@SMTH 自由Java传道士 2001 年 11 月 速度瓶颈问题的提出 在企业级的Java应用中,访问数据库是一个必备的环节.数据库作为数据资源的集散地,往往位于企业级软件体系的后方,供前方的应用程序访问.在Java技术的体系中,应用程序">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Java访问数据库的速度瓶颈问题的分析及解决</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>访问|解决|数据|数据库|速度|问题</p>
<p>内容：</p>
<p>速度瓶颈问题的提出 <br />JDBC访问数据库的机制 <br />不同模式的JDBC接口的选择 <br />Java程序中SQL语句格式的优化 <br />软件模型中对数据库访问的设计模式的优化 <br />将深入研究的问题 <br />参考资料 <br />关于作者</p>
<p>FoolsGarden@SMTH <br />自由Java传道士 <br />2001 年 11 月</p>
<p>速度瓶颈问题的提出 <br />在企业级的Java应用中，访问数据库是一个必备的环节。数据库作为数据资源的集散地，往往位于企业级软件体系的后方，供前方的应用程序访问。在Java技术的体系中，应用程序是通过JDBC（Java Database Connectivity）接口来访问数据库的，JDBC支持"建立连接、SQL语句查询、处理结果"等基本功能。在应用JDBC接口访问数据库的过程中，只要根据规范来操作，这些功能的实现不会出差错。但是，有些时候进行数据查询的效率着实让开发人员懊恼不已，明明根据规范编写的程序，却得不到预期的运行效果，造成了整个软件的执行效率不高。</p>
<p>起初，我们把问题归结于Java字节码加载和执行速度的缓慢，紧接着硬件的功能普遍得到了增强，证明这样的想法些许是错误的，还没有抓到真正的根本原因。本文将逐步解剖JDBC访问数据库的机制，深层分析造成这种速度瓶颈问题的原因，并提出在现有的Java技术框架下解决这个速度瓶颈问题的思路和方法。</p>
<p>JDBC访问数据库的机制</p>
<p>图1 <br />图2</p>
<p>图1和图2描述了Java应用程序通过JDBC接口访问数据库的4种驱动模式，也就是底层实现JDBC接口的模式。对于这些模式，我们逐一介绍：</p>
<p>模式4：图1左边的分支称为模式4，它一般是数据库厂商才能实现的纯Java的基于本地协议的驱动，直接调用DBMS（数据库管理系统）使用的网络协议，对于企业内部互联网来说，是一个实用的解决方案。</p>
<p>模式3：图1右边的分支称为模式3，它同样是一个纯Java驱动，不同于模式4的是基于网络协议。它的机制是将JDBC调用转换为中间网络协议，然后转换为DBMS协议。中间网络协议层起到一个读取数据库的中间件的作用，能够连接许多类型的数据库，因而是最灵活的JDBC模式。这种模式的产品比较适用于企业内部互联网，如若支持国际互联网，还需添加对安全、穿过防火墙访问等的支持。</p>
<p>模式1：图2左边的分支称为模式1，即通常由Sun公司提供的JDBC-ODBC桥接器。它提供了经由一种或多种ODBC驱动进行访问的JDBC接口，而ODBC驱动，在很多情况下也即数据库的客户端，必须加载到客户机。因而，它适用于下载和自动安装Java程序不重要、实验用途或者没有其它JDBC驱动可用的情况下。</p>
<p>模式2：图2右边的分支成为模式2，类似于JDBC-ODBC桥接器，需要加载到客户机，却是一个部分用Java实现的驱动接口。它将JDBC调用转换为对数据库（Oracle、Sybase、Informix、DB2等）客户端接口的调用。</p>
<p>不同模式的JDBC接口的选择 <br />以上阐述的JDBC接口的模式不同，让我们可以把JDBC接口按照实现的模式分为四类。有些同仁可能有这样的体会，选择不同的JDBC接口会有不同的访问速度，为何会出现这样的情况？这个问题的答案是，不同的应用需要不同模式的JDBC接口，因而我们在面对一个应用时，要慎重选择JDBC接口。</p>
<p>通常的DBMS都支持微软提出的ODBC规范，因而模式1可当作您在设计和实现软件时的选择，它易于配置的特性能够让你把选择JDBC等烦恼的问题暂且抛在一边，让自己的Java程序能够及早地正常工作起来。</p>
<p>一般说来，商业DBMS的提供者往往会为自己的数据库提供一个JDBC接口，应用的是模式4。这种模式的优势在于和数据库本身结合比较紧密，而且是纯Java的实现，在企业级的软件应用中，应该是首选。例如，对于Oracle数据库来说，有Oracle、SilverStream、DataDirect等公司提供这种类型的驱动，其性能往往被评价为最高效的、最可靠的驱动程序。但偶尔也有比较麻烦的情况，例如微软就不会提供MS SQL的JDBC接口，这时就需要到Sun的网站（http://industry.java.sun.com/products/jdbc/drivers）查找相关的模式4驱动，上面提到的DataDirect公司（http://www.datadirect-technologies.com/jdbc/jdbc.asp）就提供了支持MS SQL的模式4驱动，只是你需要支付750$购买这个JDBC驱动。</p>
<p>同样是纯Java实现的模式3，与模式4相比，优势在于对多种数据库的支持，体现了其灵活性。在大型的企业级的软件应用中，后台数据库往往不是一个，而且是由不同的厂商支持的。不过，模式3的JDBC驱动往往提供许多企业级的特征，例如SSL安全、支持分布式事务处理和集中管理等，因而会对你特殊的用途有很大的帮助。是否选用，还在于你对扩展应用是否有需求以及对多DBMS的支持。</p>
<p>谈到这儿，我对模式3和模式4作一个总结：两者都是纯Java实现的驱动，因而不需要数据库厂商提供附加的软件，就可以运行在任何标准的Java平台，性能上比较高效、可靠。</p>
<p>了解上述3种JDBC的实现模式之后，模式2就更容易阐释了，你可以理解它为前三者利弊平衡的妥协产物：</p>
<p>1 借鉴模式1利用客户机本地代码库，加速数据访问的执行，但却摒除ODBC标准，而是支持厂商自己指定的性能扩展 <br />2 借鉴模式3利用多层结构，上层用Java实现，利于跨平台应用和支持多数据库，但下层却改为本地代码，加速执行速度 <br />3 借鉴模式4和数据库结合紧密的优点，部分用Java实现，更是对数据库性能有很大的扩展</p>
<p>这种开放和高性能的特征得到了业界的肯定，因而被主要的数据库厂商强烈推荐。尽管它需要你下载本地代码库到客户机，但相对于你访问数据库速度的提高，这些应该只是举手之劳了。下面对4种实现JDBC的模式选择，归纳一下选择的顺序（当然是指你有选择余地的时候，不存在的话向后推延）：</p>
<p>编号 选择过程分析 选择顺序 <br />1 实验性环境下，尽可能选择易于配置的驱动，利于Java程序的开发，后期可在对应用环境进行判断后，再对JDBC模式进行选择 1&gt;2&gt;3&gt;4 <br />2 小型企业级环境下，不需要对多数据库的支持，因而模式2和3的有些优点并不能体现出来，强烈推荐你选择模式4的JDBC驱动 4&gt;2=3&gt;1 <br />3 大型企业级环境下，需要对多数据库的支持，模式2和3各有千秋，但是更多情况下是你会选择速度较快的模式2 2&gt;3&gt;4&gt;1</p>
<p>对于不同厂商提供的但应用相同模式的JDBC接口，理论上比较不出效率的高低，你只有通过一定的工具，例如Benchmark等，对它们进行比较才能更有利于你的选择。因为暂时不存在第三方提供的数据比较结果，所以这些问题需要你对上述内容有了透彻理解之后自行解决。</p>
<p>Java程序中SQL语句格式的优化 <br />这个时候，你也许还在为找不到合适的JDBC驱动而一筹莫展，也许为自己在凌晨3点下载的JDBC驱动通过了测试而欣喜若狂，但是并不说明你对程序的优化工作已经无关紧要了。切记，对整个软件系统的优化，包括每个环节的优化，要不有可能你会前功尽弃。我在这儿不和大家讨论Java程序的算法，而是简单阐述一下选择SQL语句格式的必要和如何选择对自己有利的SQL语句格式。看下面两段程序片断：</p>
<p>Code Fragment 1:</p>
<p>String updateString = "UPDATE COFFEES SET SALES = 75 " + "WHERE COF_NAME LIKE ´Colombian´"; <br />stmt.executeUpdate(updateString);</p>
<p>Code Fragment 2:</p>
<p>PreparedStatement updateSales = con.prepareStatement("UPDATE COFFEES SET SALES = ? WHERE COF_NAME LIKE ? "); <br />updateSales.setInt(1, 75); <br />updateSales.setString(2, "Colombian"); <br />updateSales.executeUpdate();</p>
<p>片断2和片断1的区别在于，后者使用了PreparedStatement对象，而前者是普通的Statement对象。PreparedStatement对象不仅包含了SQL语句，而且大多数情况下这个语句已经被预编译过，因而当其执行时，只需DBMS运行SQL语句，而不必先编译。当你需要执行Statement对象多次的时候，用PreparedStatement对象将会大大降低运行时间，当然也加快了访问数据库的速度。</p>
<p>这种转换也给你带来很大的便利，不必重复SQL语句的句法，而只需更改其中变量的值，便可重新执行SQL语句。选择PreparedStatement对象与否，在于相同句法的SQL语句是否执行了多次，而且两次之间的差别仅仅是变量的不同。如果仅仅执行了一次的话，它应该和普通的Statement对象毫无差异，体现不出它预编译的优越性。</p>
<p>软件模型中对数据库访问的设计模式的优化 <br />在我阅读J2EE蓝图和JDO草案的过程中，我发现了访问模式对数据库访问的影响，因而想在本文中阐述如何针对自己的软件需求选择合适的软件模式。</p>
<p>J2EE蓝图的设计者在Java Pet Store示例应用中使用了MVC（Model-View-Controller）体系，给许多J2EE设计模式提供了背景。我要谈及的三种设计模式是：Data Access Object、Fast Lane Reader、Page-by-Page Iterator，它们为加快数据存取速度提供了一些可以在系统设计阶段值得我们借鉴的想法。</p>
<p>Data Access Object <br />将商业逻辑从数据存取逻辑中分离出来，把存取的资源改编，从而使资源可以容易和独立地转变。</p>
<p>依赖于底层数据资源的特殊要素（例如数据库的供应商）的商业组件，常将商业逻辑和数据存取逻辑配合起来，只能使用特殊类型的资源，而使用不同类型的资源时，复用将会非常困难，因此，只能服务于有限的市场领域。DAO（Data Access Object）即是将数据存取逻辑从EJB中抽去出来抽象为一个独立的接口，EJB根据接口的操作执行商业逻辑，而接口针对使用的数据资源实现为DAO对象。</p>
<p>在Java Pet Shop这个例子中，OrderEJB组件通过关联的OrderDAO类访问数据库，自身则关注于商业逻辑的实现。在调度阶段，将配置某一类（OrderDAOCS、OrderDAOOracle或OrderDAOSybase）为OrderDAO的实现，而OrderEJB无须任何更改。图3更能帮助你明白其中的道理：</p>
<p>图3 Data Access Object的设计模式</p>
<p>此举增加了数据存取的弹性、资源的独立性和扩展性，但复杂度有相应的提高，其它附带的问题我们不在这儿讨论。</p>
<p>Fast Lane Reader <br />抛弃EJB，加速只读数据的存取。</p>
<p>有些时候，高效地存取数据比获得最新的数据更重要。在Java Pet Store中，当一个用户浏览商店的目录时，屏幕与数据库内容吻合不是至关紧要的，相反，迅速显示和重新获得非常重要。FLR模式可以加速从资源中重新获得大型的列数据项的速度，它不用EJB，而是更直接地通过DAO来存取数据，从而消除EJB的经常开支（例如远程方法调用、事务管理和数据序列化等）。</p>
<p>在Java Pet Store这个例子中，当一个用户浏览目录时，通过CatalogDAO（而不是CatalogEJB）从数据库加载数据项，而CatalogDAO是一个Fast Lane Reader的实例，使得读访问变得迅速，如图4：</p>
<p>图4 Fast Lane Reader设计模式</p>
<p>与DAO模式不同的是，FLR是一个优化的模式，但不是要替代原有的访问机制，而是作为补充使其完备。当你频繁地只读大型的列数据和不必存取最新的数据时，使用FLR将是非常合适的。</p>
<p>Page-by-Page Iterator <br />为了高效地存取大型的远程数据列，一下子通过重新获得其元素为一个子列的Value Object（提高远程传输效率的设计模式，这儿不详尽描述）。</p>
<p>分布式数据库的应用经常需要用户考虑一长列数据项，例如一个目录或一个搜索结果的集合。在这些情况下，立刻提供全列的数据经常不必要（用户并不是对所有的数据项感兴趣）或不可能（没有足够的空间）。此外，当重新获得一列数据项时，使用Entity Bean的代价将非常高昂，一个开销来自于使用远程探测器来收集Requested Bean，另外，更大的开销来自对每个Bean产生远程调用以从用户获得数据。</p>
<p>通过Iterator，客户机对象能一下子重新获得一个子列或者页的Value Object，每一页都刚好满足客户机的需求，因此，程序使用较少的资源满足了客户机的立刻需求。</p>
<p>在Java Pet Store这个例子中，JSP页面product.jsp任何时候只显示一个数据列的一部分，从ProductItemListTag（Page-by-Page Iterator）重新获得数据项，当客户机希望看到列中的别的数据项，product.jsp再次调用Iterator重新获得这些数据项，流程见图5：</p>
<p>图5 Page-by-Page Iterator设计模式</p>
<p>以上设计模式的应用向我们表明，在某些特殊情况下，优化对数据库的访问模型，既可满足用户的需求又可提高访问数据库的效率。这给我们一个思路，就是：在你的硬件环境可能会产生瓶颈的情况下，可以通过对软件模型的优化来达到满足需求的目的。上述三种设计模式的应用情形为：</p>
<p>Data Access Object 需要将商业逻辑和数据存取逻辑分离； <br />在调度的时刻，需要支持选择数据源的类型； <br />使用的数据源的类型的变化，对商业对象或其它客户端完成数据存取没有影响。 <br />Fast Lane Reader 面对大型的列数据，需要经常的只读访问； <br />访问最新的数据并不是至关紧要的事情。 <br />Page-by-Page Iterator 存取大型的服务器端数据列； <br />任何时刻，用户只对列的一部分内容感兴趣； <br />整个列的数据不适合在客户端显示； <br />整个列的数据不适合在存储器中保存； <br />传输整个列的数据将耗费太多的时间。</p>
<p>在显示商品目录的时候，我们选择了DAO和FLR的结合，因为它们两者的条件都得到了满足（需要分离商业逻辑和数据存取逻辑，经常的只读访问和对即时性不敏感），此时应用将会大大发挥它们的优点。而在进行内容检索的时候，我们会选择PPI，因为也许检索出了上千条的记录，但是用户没有兴趣立即阅读全部内容，而是一次十条地阅读，或者他在阅读完前十条记录后发觉自己的目的已经达到，接下来浏览别的网页了，都不必我们一次性地传输上千条记录给他，所以也是PPI的应用条件得到了满足，结果则是此模式的优点得到了发挥，又不影响全局的数据访问。</p>
<p>在进行软件模型的设计时，整体的框架可以应用某些优秀的、通用的设计模式，这样既加快模型的建立速度，又能和其它系统集成。但是，碰到一些瓶颈问题的情况下，我们就需要对局部的设计模式做一些调整，以优化整个系统，上述三个模式就是对原有体系的补充，它们并没有对整体的框架做出巨大的改变，却突破了某些瓶颈（瓶颈往往是局部的）障碍，让我们的产品更好地服务于用户。</p>
<p>将深入研究的问题 <br />开篇至今，我们主要探讨了软件层次上的解决问题，但是，必须肯定一点，如果你的硬件环境非常差（运行Java都有困难）或非常好（额外的存储空间、超快的运算速度和富裕的网络带宽），上述途径对你来说很难有大的帮助。前一种情况，我建议你升级硬件设备到软件厂商推荐的配置（强烈反对最小配置），以使应用服务器、数据库、Java等软件能够运行自如；后一种情况，我没什么话可说，花钱是解决这个问题最好的办法。</p>
<p>本文并未谈及线程池和告诉缓冲这两个非常重要的概念，因为笔者认为，它们是针对局部时间高访问量的瓶颈问题的解决，不能理解为简单的速度瓶颈问题，所以我会在下一篇文章中分析这种特殊的情况和提出解决问题的办法。也许你对这一点更关心一些，认为自己的问题就出在这个地方，这是非常好的思考问题的方式，你已经抓住了问题的关键。但是，我还是建议你通读一下本文，让自己对速度瓶颈问题有更好的理解，并掌握在解决问题的过程中，分辨常态和暂态，从而选择不同的思路入手。其实，本文谈及的就是速度瓶颈问题的常态，而下一篇文章讨论的将会是暂态，希望你能够渐入佳境。</p>
<p>JDO（Java Data Object）是需要我们关注的一个API，它定义了新的数据存取模型，直接借鉴了DAO设计模式。不同的数据源，有不同的数据存取技术，就有不同的API供开发人员使用。JDO正是为了解决这个问题而产生的，它实现了即插即用的数据存取的实现和持久信息（包括企业数据和本地存储的数据）以Java为中心的视图。因此，开发人员只关注创建那些实现商业逻辑的类和用它们来表现数据源的数据，而这些类和数据源之间的映射则由那些EIS领域的专家来完成。如果大家对JDO感兴趣的话，那么我会写第三篇文章把其详细介绍给大家，并给出示例应用。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 17:44:03</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%97%ae%e9%a2%98/" title="问题">问题</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae/" title="数据">数据</a>, <a href="https://www.iamivan.net/tag/%e9%80%89%e6%8b%a9/" title="选择">选择</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%bc%8f/" title="模式">模式</a>, <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%8f%96/" title="存取">存取</a>, <a href="https://www.iamivan.net/tag/%e8%ae%bf%e9%97%ae%e8%80%85%e6%a8%a1%e5%bc%8f/" title="访问者模式">访问者模式</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Java访问数据库的速度瓶颈问题的分析及解决的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQ36Dp.html" rel="bookmark">JAVA访问数据库之概述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JAVA类库中包含一组用于访问数据库的接口和类,作为开发数据库应用程序的API.这些接口和类统称为JDBC(Java DataBase Connectivity),JDBC是访问数据库的类和接口的结合.对于数据库的操作,在整个Java学习过程中至关重要. JDBC简介 JDBC提供了连接各种常用数据库的能力.有了JDBC,访问数据库就是一件很容易的事,有了JDBC,就不必为访问Sysbase数据库和Oracle数据库来专门写一个程序.程序员只需要JDBC API写一个程序就可以了,它可以向相应的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx26k7z.html" rel="bookmark">JAVA访问数据库之连接数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开发一个访问数据库的应用程序,首先要加载数据库的驱动程序,只需要在第一次访问数据库时加载一次,然后每次运行时创建一个Connection实例,紧接着执行操作数据库的SQL语句,并处理返回的结果集,最后在完成完成此次操作时销毁前面创建的Connection,释放与数据库的连接. 加载数据库驱动 在连接数据库之前,首先要把JDBC驱动类加载到java虚拟机,可以使用java.lang.Class类的静态方法forName(String className).成功加载后会将加载的驱动类注册给Drive			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9bBZmJb.html" rel="bookmark">局域网速度变慢原因分析及解决办法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  网络变慢是经常会遇到的问题,对于ADSL专线单独使用网络的用户来说,网络速度出现变慢的情况比较少.但是对于局域网接入上网的用户而言就会经常出现,例如网吧.公司和学校企业等地点.很多用户反应,局域网在运行一段时间后,发现整个网络网速突然变慢:运行公司信息系统软件和访问公司局域网内主页速度明显降低,访问外网速度也大不如前. 遇到网络变慢的情况,就要对网络进行有效的诊断,引起局域网网速减慢的原因很多,网线的状况.网线的接头.集线器.网卡,以及驱动程序等等硬件设备都可能引起企业局域网网速减慢. 这种			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPZnXqb.html" rel="bookmark">MySQL---数据库从入门走向大神系列&lpar;七&rpar;-Java访问数据库配置及简单使用方法execute</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从操作配置文件properties中读取连接字符串,通过该字符串进行数据连接,需要写三个文件其中,两个是java类,一个是后缀名为.properties的文件,该文件放在src工作目录下. 需要准备的包: https://github.com/chenhaoxiang/Java 后缀为.properties的文件此处为其取名为jdbc.properties,其中的代码如下: ##MySQL driver=com.mysql.jdbc.Driver url=jdbc:mysql://127.0.0			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6eDAM.html" rel="bookmark">JAVA访问数据库之增删改查&lpar;CRUD&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上一篇博客介绍了如何使用JAVA连接数据库,那么这一篇将继续为大家介绍如何使用JDBC对数据库的增删改查(CRUD)操作. 这一篇博客中的示例将使用上一篇中生成的H2数据库文件. 查询 查询在数据库的操作中是很重要的,我们把数据保存在数据库中,就是为了我们在需要的时候能够快速.高效的查询出来. /** * 查询 * * @throws Exception */ public void query() throws Exception { Connection conn = getConnecti			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MgPN4Op.html" rel="bookmark">C&num;访问数据库&hellip;列不属于表的问题 怎么解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 LinkDataBase.Open();stringusername=this.textBox1.Text;stringpassword=this.textBox2.Text;DataTabledt=LinkDataBase.GetUserInfo();stringid=dt.Rows[0][0].ToString();intcount=dt.Rows.Count;stringselectsql=&quot;select*from用户权限wheresysuser='&quot;+username			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLm52kz.html" rel="bookmark">java&period;lang&period;OutOfMemoryError&colon; GC overhead limit exceeded 问题分析和解决&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在项目历史数据导入过程中,出现了应用无法访问的情况.立刻对Weblogic进行分析,发现Weblogic的内存.线程等性能良好,Server也是Running的状态.随后查看了Weblogic日志,在日志中发现下述错误   通过排查问题后得出造成此类问题的原因是,项目的一个模块在批量导入数据,程序需要New一个很大的对象,GC发现内存不够后,对内存进行回收,但是发现回收后的内存还不能满足大对象的需要.应此造成了内存溢出.   解决方案:调大Weblogic的启动内存即可.   http://bl			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk2e3wM.html" rel="bookmark">计算机登陆域速度慢问题的分析和解决</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Windows 2000/XP客户端登录到Windows 2000域时非常慢,主要表现为当域用户在登录对话框中输入用户名和密码之后登录对话框一片灰白,而且要持续很久,象失去反应一样(正常情况是登录窗口一闪而过),登录过程和启动过程明显比正常情况长. 问题的分析 从现象表现来看,好像是客户端没能很快联系到域控制器,因为输入用户名和密码之后一片灰白没有反应,那为什么没能很快联系到域控制器呢?因为Windows 2000/XP客户端登录域时是先根据它的DNS设置找到DNS服务器,以查找DNS服务器里面			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ba40gJz.html" rel="bookmark">使用delphi 开发 web（五）Android 与delphi 服务器交互访问数据库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     近2年,随着智能手机及平板电脑的快速发展,同时伴随着3G 网络的逐渐普及,移动开发越来越受到开发人员的青睐,而谷歌推出的Android 系统以其开放.优秀很快受到开发人员的推崇,很多知名网站都推出了Android 客户端版本,例如腾讯.新浪.淘宝都有对应的版本.同时很多数据库应用程序都从原来的windows 桌面程序延伸到移动设备上,由于移动设备的性能及内存等肯定无法与台式机及笔记本电脑相比,因此访问数据库也不可能像桌面安装各种数据库的客户端,当然目前绝大多数数据库也没有直接运行在移动			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/4MYRv5p.html" rel="bookmark" class="title">mathtype怎样修改字体大小</a>
					<div>
						  1.双击公式打开MathType编辑窗口,在MathType菜单栏上,选择&quot;样式&quot;--&quot;定义&quot;. 2.在弹出的对话框中,点击&quot;高级&quot;就可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrXo1z.html" rel="bookmark" class="title">PS快速给美女换上搞笑的男士头像</a>
					<div>
						  原图 最终效果 2.然后把男士图层的不透明度调成50%,CTRL+T调整大小,要和美女的五官对称. 3.CTRL+男士图层建立选区,建立&quot;蒙板&quot;.选画笔工具,这时要把前.后景色 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgkQ1M.html" rel="bookmark" class="title">网页设计商品价目表最佳设计策略</a>
					<div>
						作者:György Fekete 原文链接:Pricing Tables: Examples And Best Practices译者:UCD翻译小组, LanxGyörgy Fekete 版权所有( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQJVOM.html" rel="bookmark" class="title">PS破绽百出（1）</a>
					<div>
						PS破绽百出,您自己看下就看得出了. 现在大家上网看图片也许第一个想到的就是:&quot;这图是不是PS的&quot;,从&quot;周老虎&quot;事件开始,人们更开始关注图片的真伪性! 今天开始 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7v1Xp.html" rel="bookmark" class="title">利用友链平台&OpenCurlyDoubleQuote;穿壁引光&rdquo;提升网脉</a>
					<div>
						友情链接平台相信各大站长都知道,无论新站还是老站都要友链交换的工作,笔者最近负责公司网站友情交换,之前手上也没什么资源,只能在网上寻找.仔 细研究了下,网上的友链平台分类挺多的,有交换形式的,有出售形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeBd7b.html" rel="bookmark" class="title">J2ME Personal Information Management &lpar;PIM&rpar; 概览</a>
					<div>
						移动环境中的 Personal Information Management (PIM) 随着新设备不断上市,在移动设备上提供 Address Book.Calendar 和 Task List 成为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlXZmb.html" rel="bookmark" class="title">ASP&period;NET中的程序权限问题</a>
					<div>
						谈到ASP.NET程序的权限,一般可分为两种: 1) 账户的权限. 2) 代码的权限. 账户的权限可以限制运行在这个账户下的所有ASP.NET程序能进行什么样的操作,而代码的权限是ASP.NET程序里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKvd6M.html" rel="bookmark" class="title">Windows主机网站伪静态设置httpd&period;ini</a>
					<div>
						网站建设技术不断在变化,早期学习建站的时候都是用的动态页面,后来又流行生成静态的效果.但是如果由于网站信息量大,生成静态之后网站的体积将会特别的庞大,如果我们要修改模板,生成全站静态估计够吃力.目前较 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3KOEM.html" rel="bookmark" class="title">jQuery制作拼图小游戏</a>
					<div>
						 这篇文章主要介绍了jQuery制作拼图小游戏,思路与源码都分享给大家,需要的朋友可以参考下     源代码思路分析: [一]如何生成图片网格,我想到两种方法: (1)把这张大图切成16张小图,然后用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z72GBAp.html" rel="bookmark" class="title">Win8如何开启隐藏Administrator账户</a>
					<div>
						  Win8开启隐藏Administrator账户的方法如下: 1.将鼠标放到右下角. 2.点击搜索. 3.搜索cmd,然后点击应用. 4.在搜索出来程序上右键,选择以管理员身份运行. 5.用户帐户控 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg3j8OM.html" rel="bookmark" class="title">form表单内的内容用post上传后在php界面怎么接受自动转化为h1和p？</a>
					<div>
						问题描述 form表单内的内容用post上传后在php界面怎么接受自动转化为h1和p? 一个标题输入,一个textarea输入,在该页面点击提交在php界面要怎么接收?然后自动转化为h1和p,要保留t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxgZ8b.html" rel="bookmark" class="title">radiobutton-如何设置两个RadioButton之间间隔&comma;让它们等间距排列</a>
					<div>
						问题描述 如何设置两个RadioButton之间间隔,让它们等间距排列 用RadioButton的时候它们总是会挤在一起,有没有哪位大神有办法教教我,让RadioButton之间有间隔,让它们等间距排 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkBJ8b.html" rel="bookmark" class="title">hbase启动后hmaster进程消失的问题</a>
					<div>
						问题描述 hbase启动后hmaster进程消失的问题 hadoop-2.4.1+zookeeper-3.4.5(非hbase自带)+hbase-0.96.2-hadoop2 无论执行什么命令,都报一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamyd2b.html" rel="bookmark" class="title">spring mvc中使用post方式请求返回405</a>
					<div>
						问题描述 spring mvc中使用post方式请求返回405 后台处理方法 @RequestMapping(value=&quot;&quot;/doLogin&quot;&quot; method ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRxX3b.html" rel="bookmark" class="title">《Unity着色器和屏幕特效开发秘笈（原书第2版）》&mdash;&mdash;2&period;4　给着色器添加纹理</a>
					<div>
						2.4 给着色器添加纹理 在模拟现实效果方面,纹理可以让着色器迅速生动起来.为了高效使用纹理,我们需要理解二维图像是如何映射成三维模型的.这个映射过程称为纹理映射.为了进行纹理映射,我们需要在着色器和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl4kXp.html" rel="bookmark" class="title">windows-nodejs上每敲出一个代码都会返回undefined</a>
					<div>
						问题描述 nodejs上每敲出一个代码都会返回undefined 如题,我用windows的nodejs,在cmd下进入node,敲出一行代码都会返回undefined,这是为什么? 解决方案 因为返 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5ogVM.html" rel="bookmark" class="title">何去何从？</a>
					<div>
						问题描述 收到二份offer.不知如何选择,大家帮我看一下.A:集团公司,所有员工大概在50,60(中国区)之间,工资,税前8K,有车贴和饭贴,四金(公积金),所有加加减减,到手,应该在7100左右, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK7lnb.html" rel="bookmark" class="title">ios-iOS 怎么样打包ipa，用来上传到非AppStore平台</a>
					<div>
						问题描述 iOS 怎么样打包ipa,用来上传到非AppStore平台 知道怎么打包,但是要怎么输出ipa呢,以前只试过上传到AppStore和adhoc,求指教 解决方案 开发]如何将应用打包成.ip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0nPdAz.html" rel="bookmark" class="title">Spring整合Quartz 疑问</a>
					<div>
						问题描述 spring配置:&lt;beanid=&quot;workLoadSchedule&quot;class=&quot;org.springframework.scheduling.quar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12APap.html" rel="bookmark" class="title">3d mesh compression-最近在看3D mesh compression类论文，哪位大神有具体实现的代码啊！</a>
					<div>
						问题描述 最近在看3D mesh compression类论文,哪位大神有具体实现的代码啊! 看的都是理论的东西,想具体看看如果实现该怎样做,想参考一下,谢谢!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgrEoM.html" rel="bookmark" class="title">如何加入群组</a>
					<div>
						问题描述 如何加入群组,请速度回答 问题补充:ITeye管理员 写道 解决方案 打开该群组的首页 点&quot;申请加入&quot;就行了					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YBy9z.html" rel="bookmark" class="title">龙芯创新在哪里？意义又在哪里？</a>
					<div>
						看到龙芯签约MIPS,写了一篇&lt;龙芯签约MIPS自主产权CPU核战略失败&gt;,没想到被新浪推到显著问题,其实老杳只想用龙芯签约MIPS说明国家十年来力推自主知识产权CPU核战略的失误,至于龙 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jYPdp.html" rel="bookmark" class="title">如何设计父类使得每个子类都继承并重写父类的一个static方法？</a>
					<div>
						问题描述 RT.java能办到吗?或者有没有其他办法? 解决方案 解决方案二:父类中的static方法是不可以重写的解决方案三:引用1楼jqctop1的回复: 父类中的static方法是不可以重写的  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYAR6b.html" rel="bookmark" class="title">jquery checkbox全选反选实现代码</a>
					<div>
						在jquery中我们要判断checkbox是否选中我们可以直接使用 if($(&quot;#id&quot;).attr(&quot;checked&quot;)==true) 来操作. 那么如果我们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJO892b.html" rel="bookmark" class="title">sql server-如何修改将对象类型1修改成不包含，0修改成包含</a>
					<div>
						问题描述 如何修改将对象类型1修改成不包含,0修改成包含 SELECT A.iIden ,A.状态 ,A.创建人 ,B.对象类型 FROM dbo.升级包 A WITH(NOLOCK) JOIN db ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW6Akz.html" rel="bookmark" class="title">c语言&percnt;x在不同函数中是一样的吗</a>
					<div>
						问题描述 c语言%x在不同函数中是一样的吗 scanf函数和printf函数中的%x都是无符号十六进制整数还是不一样的? 解决方案 在不同编译器上,表示的长度可能是不同的,对于相同的编译器,就是相同的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenx08b.html" rel="bookmark" class="title">斯威夫特与佩里同台英国青少年大奖明星闪耀</a>
					<div>
						凯蒂-佩里卖力演唱 泰勒-斯威夫特演出中 新浪娱乐讯 北京时间11月16日消息,据国外媒报道,由英国BBC广播一台举办的2010年青少年大奖(Teen Award)上周日在伦敦的Hammersmith ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1DdWrb.html" rel="bookmark" class="title">SharePoint 2010 Silverlight托管客户端模型简单示例</a>
					<div>
						Silverlight托管客户端模型,是SharePoint2010推出的三种客户端模型&quot;.NET托管&quot;.&quot;ECMAScript&quot;.&quot;Sliverli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenD7Nb.html" rel="bookmark" class="title">首席信息官将被首席数据官取代？</a>
					<div>
						随着信息化的推进,企业信息化资产管理愈发重要,于是出现了一种新型企业管理人员--首席数据官(CDO,Chief Data Officer). 近两年,分析师和研究人员一直就CIO(Chief Info ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwy0jWM.html" rel="bookmark" class="title">金航数码有哪位仁兄了解么？</a>
					<div>
						问题描述 接到金航的offer,不知道有那么兄弟了解该公式情况,能否透露一点. 解决方案 总公司不清楚,成都分公司,待遇一般般,其它福利稍好,好像是国资委背景,做产品.解决方案二:很有背景的一家公司, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.088 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
